/*++

Copyright (c) Sydus.

Module:

    Rc4.h

Authors:

    Sharvil Nanavati (sharvil) 2006-10-31

--*/

#pragma once

#include "base.h"
#include "ICryptosystem.h"

class Rc4 : public ICryptosystem
{
	public:
		explicit Rc4(const BString & key);
		Rc4(const uint8 * key, uint32 keyLength);
		~Rc4();

		void Encrypt(BString & data);
		void Decrypt(BString & data);

		void Encrypt(uint8 * data, uint32 length);
		void Decrypt(uint8 * data, uint32 length);

	private:
		static const uint32 csSubstitutionBoxSize = 256;

		void Initialize(const uint8 * key, uint32 keyLength);

		uint8 iIterator;
		uint8 iSwapper;
		uint8 iSubstitutionBox[csSubstitutionBoxSize];
};
