/*++

Copyright (c) Sydus.

Module:

    ISelectable.h

Authors:

    Sharvil Nanavati (sharvil) 2005-02-13

--*/

#pragma once

#include "base.h"
#include "Selector.h"

class ISelectable
{
	public:
		ISelectable();
		virtual ~ISelectable();

		void Register(Selector & selector, uint32 flags);
		void Unregister();

		uint32 GetInterestFlags() const;
		void SetInterestFlags(uint32 flags);

	protected:
		virtual int32 GetFd() const = 0;

	private:
		Selector * iSelector;
		uint32 iInterestFlags;
		int32 iRegisteredFd;
};
