/*++

Copyright (c) Sydus.

Module:

    TcpClient.h

Authors:

    Sharvil Nanavati (sharvil) 2005-08-25
    Emily Johnston (emily) 2005-12-23

--*/

#pragma once

#include "base.h"
#include "ClientSocket.h"

class InetAddress;

class TcpClient : public ClientSocket
{
	public:
		TcpClient();
		virtual ~TcpClient();

		void EnableKeepAlive(int32 idleTime = -1, int32 interval = -1, int32 numProbes = -1);
		void DisableKeepAlive();

		const InetAddress & GetRemoteAddress() const;

		void EnableNagle();
		void DisableNagle();

	protected:
		// Make the server a friend who can instantiate this class with a socket
		friend class TcpServer;
		TcpClient(ISocketImplementation * socket);
};
