/*++

Copyright (c) Sydus.

Module:

    Directory.h

Authors:

    Sharvil Nanavati (sharvil) 2007-10-25

--*/

#pragma once

#include "base.h"

class Directory
{
	public:
		struct Entry
		{
			std::string iName;
			bool iIsDirectory;
		};

		typedef std::list <Entry> List;

		static std::string PathFromFile(const std::string & filename);
		static std::string GetCurrent();
		static void SetCurrent(const std::string & directory);

		explicit Directory(const std::string & path);

		List ListAll() const;

	private:
		std::string iPath;
};
