/*++

Copyright (c) Sydus.

Module:

    Module_Win32.h

Authors:

    Sharvil Nanavati (sharvil) 2006-03-25

--*/

#pragma once

#include "base.h"

class Module_Win32
{
	public:
		Module_Win32();
		explicit Module_Win32(const std::string & filename);
		~Module_Win32();

		void Open(const std::string & filename);
		void Close();

		template <typename T>
		bool ReadSymbol(const std::string & name, T & symbol);

	private:
		HMODULE iHandle;
};

template <typename T>
bool Module_Win32::ReadSymbol(const std::string & name, T & symbol)
{
	if(iHandle == 0)
		return false;

	symbol = (T)GetProcAddress(iHandle, name.c_str());
	return (symbol != (T)0);
}
