/*++

Copyright (c) Sydus.

Module:

    SSConnectionPool.h

Authors:

    Sharvil Nanavati (sharvil) 2008-04-27

--*/

#pragma once

#include "base.h"
#include "SSConnection.h"
#include "NetLib.h"

#include <map>

class SSConnectionPool : public ISelectable
{
	private:
		typedef std::map <InetAddress, SSConnection *> map_t;

	public:
		typedef map_t::iterator iterator;
		typedef map_t::const_iterator const_iterator;

		SSConnectionPool();
		~SSConnectionPool();

		void Bind(uint16 port);

		SSConnection & Connect(const std::string & name, const InetAddress & address);
		SSConnection * GetConnection(const InetAddress & address);
		SSConnection * GetConnection(const std::string & name);

		void Poll();

		iterator begin();
		iterator end();

		const_iterator begin() const;
		const_iterator end() const;

	private:
		int32 GetFd() const;

		UdpServer iSocket;
		map_t iConnections;
};
