/*++

Copyright (c) Sydus.

Module:

    Thread.h

Authors:

    Sharvil Nanavati (sharvil) 2006-03-22

--*/

#pragma once

#include "base.h"

class IThreadImplementation;

//
// NOTE: all subclasses MUST implement a destructor that calls Join().
//
class Thread : private NonCopyable
{
	public:
		Thread();
		virtual ~Thread();

		void Start();
		void Join();
		bool IsAlive() const;

		virtual void Run() = 0;

	protected:
		void Exit();

	private:
		IThreadImplementation * iPimpl;
};
