/*++

Copyright (c) Sydus.

Module:

    Thread_Win32.h

Authors:

    Sharvil Nanavati (sharvil) 2006-03-22

--*/

#pragma once

#include "base.h"
#include "IThreadImplementation.h"

class Thread;

class Thread_Win32 : public IThreadImplementation
{
	friend class Thread;

	private:
		Thread_Win32(Thread & parent);
		~Thread_Win32();

		void Start();
		void Join();
		void Exit();

		bool IsAlive() const;

	private:
		static DWORD WINAPI EntryPoint(void * self);

		Thread & iParent;
		HANDLE iThreadHandle;
};
