/*++

Copyright (c) Sydus.

Module:

    platform.h

Authors:

    Sharvil Nanavati (sharvil) 2006-01-01
    Serge Zloto (szloto) 2006-01-03

--*/

#pragma once

#if defined(_WIN32)

#	define PLATFORM_WIN32
#	define _WIN32_WINNT 0x400
#	define _USE_MATH_DEFINES
#	define NOMINMAX
#	define WIN32_LEAN_AND_MEAN
#	include <winsock2.h>
#	include <windows.h>
#	undef C_ASSERT

//
// If we're doing a Wine build, __GNUC__ will also be set.
//
#	if !defined(__GNUC__)
#		define strcasecmp _stricmp
		typedef SSIZE_T ssize_t;
#	endif

#elif defined(__MACH__) && defined(__APPLE__)

#	define PLATFORM_MACOSX

#endif

#if defined(__GNUC__)

#	include <ext/hash_map>
	using __gnu_cxx::hash_map;

#elif defined(PLATFORM_WIN32)

#	include <hash_map>
	using stdext::hash_map;

#endif
